<?php
jimport('joomla.plugin.plugin');
class plgSystemHikashopuser extends JPlugin{
	function plgSystemHikashopuser(&$subject, $config){
		parent::__construct($subject, $config);
		$app =& JFactory::getApplication();
		$this->cart = $app->getUserState('com_hikashop.cart_id');
		$this->currency = $app->getUserState('com_hikashop.currency_id');
		$this->entries = $app->getUserState('com_hikashop.entries_fields');

//		$this->payment = $app->getUserState( HIKASHOP_COMPONENT.'.payment_method');
//		$this->payment_id = $app->getUserState( HIKASHOP_COMPONENT.'.payment_id');
//		$this->payment_data = $app->getUserState( HIKASHOP_COMPONENT.'.payment_data');
//		$this->cc_number = $app->getUserState( HIKASHOP_COMPONENT.'.cc_number');
//		$this->cc_month = $app->getUserState( HIKASHOP_COMPONENT.'.cc_month');
//		$this->cc_year = $app->getUserState( HIKASHOP_COMPONENT.'.cc_year');
//		$this->cc_CCV = $app->getUserState( HIKASHOP_COMPONENT.'.cc_CCV');
//		$this->cc_type = $app->getUserState( HIKASHOP_COMPONENT.'.cc_type');
//		$this->cc_owner = $app->getUserState( HIKASHOP_COMPONENT.'.cc_owner');
		}

		function onUserBeforeSave($user, $isnew, $new){
			return $this->onBeforeStoreUser($user, $isnew);
	}
	function onUserAfterSave($user, $isnew, $success, $msg){
		return $this->onAfterStoreUser($user, $isnew, $success, $msg);
	}
	function onUserAfterDelete($user, $success, $msg){
		return $this->onAfterDeleteUser($user, $success, $msg);
	}
	function onUserLogin($user, $options){
		return $this->onLoginUser($user, $options);
	}

	function onBeforeStoreUser($user, $isnew){
		$this->oldUser = $user;
		return true;
	}
	function onAfterStoreUser($user, $isnew, $success, $msg){
		if($success===false || !is_array($user)) return false;
		if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php')) return true;
		$userClass = hikashop_get('class.user');
		$hikaUser = null;
		$hikaUser->user_email = trim(strip_tags($user['email']));
		$hikaUser->user_cms_id = (int)$user['id'];
		if(!empty($hikaUser->user_cms_id)){
			$hikaUser->user_id = $userClass->getID($hikaUser->user_cms_id,'cms');
		}
		if(empty($hikaUser->user_id) && !empty($hikaUser->user_email)){
			$hikaUser->user_id = $userClass->getID($hikaUser->user_email,'email');
		}
		$oldUser = $userClass->get($hikaUser->user_id);
		$fieldsClass = hikashop_get('class.field');
		$element = $fieldsClass->getInput('user', $oldUser);
		foreach($element as $key => $value) {
			$hikaUser->$key = $value;
		}

		//only save the info if the user already exists in hikashop.
		if(!empty($hikaUser->user_id)){
			$userClass->save($hikaUser,true);
		}
		return true;
	}
	function onAfterDeleteUser($user, $success, $msg){
		if($success===false || !is_array($user)) return false;
		if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php')) return true;
		$userClass = hikashop_get('class.user');
		$user_id = $userClass->getID($user['email'],'email');
		if(!empty($user_id)){
			$userClass->delete($user_id,true);
		}
		return true;
	}
	function onLoginUser($user, $options){

		$app =& JFactory::getApplication();
		$cart = $app->getUserState('com_hikashop.cart_id');
		//it's really important to check on $cart, otherwise, it doesn't work with the normal joomla login
		if(empty($cart) && !empty($this->cart)){
			$app->setUserState('com_hikashop.cart_id',$this->cart);
		}
		$entries = $app->getUserState('com_hikashop.entries_fields');
		if(empty($entries) && !empty($this->entries)){
			$app->setUserState('com_hikashop.entries_fields',$this->entries);
		}
		$currency = $app->getUserState('com_hikashop.currency_id');
		if(empty($currency) && !empty($this->currency)){
			$app->setUserState('com_hikashop.currency_id',$this->currency);
		}
//		$payment = $app->getUserState( HIKASHOP_COMPONENT.'.payment_method');
//		$app->setUserState( HIKASHOP_COMPONENT.'.cc_number',base64_encode($cc_number));
//		$app->setUserState( HIKASHOP_COMPONENT.'.cc_month',base64_encode($cc_month));
//		$app->setUserState( HIKASHOP_COMPONENT.'.cc_year',base64_encode($cc_year));
//		$app->setUserState( HIKASHOP_COMPONENT.'.cc_CCV',base64_encode($cc_CCV));
//		$app->setUserState( HIKASHOP_COMPONENT.'.cc_type',base64_encode($cc_type));
//		$app->setUserState( HIKASHOP_COMPONENT.'.cc_owner',base64_encode($cc_owner));

		if(empty($user['id'])){
			if(!empty($user['username'])){
				jimport('joomla.user.helper');
				$instance = new JUser();
				if($id = intval(JUserHelper::getUserId($user['username'])))  {
					$instance->load($id);
				}
				if ($instance->get('block') == 0) {
					$user_id=$instance->id;
				}
			}
		}else{
			$user_id = $user['id'];
		}

		if(!empty($user_id)){
			if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php')) return true;
			$userClass = hikashop_get('class.user');
			$hika_user_id = $userClass->getID($user_id,'cms');
			if(!empty($hika_user_id)){
				$addressClass = hikashop_get('class.address');
				$addresses = $addressClass->getByUser($hika_user_id);
				if(!empty($addresses) && count($addresses)){
					$address = reset($addresses);
					$field = 'address_country';
					if(!empty($address->address_state)){
						$field = 'address_state';
					}
					$zoneClass = hikashop_get('class.zone');
					$zone = $zoneClass->get($address->$field);
					if(!empty($zone)){
						$zone_id = $zone->zone_id;
						$app->setUserState( HIKASHOP_COMPONENT.'.zone_id', $zone->zone_id );
					}
				}

			}
		}

	}

	function onUserLogout($user){
		return $this->onLogoutUser($user);
	}

	function onLogoutUser($user){
		$options=null;
		return $this->onLoginUser($user, $options);
	}

	function onAfterRender(){
		$option = JRequest::getCmd('option');
		$view = JRequest::getCmd('view');
		$task = JRequest::getCmd('task');
		$layout = JRequest::getCmd('layout');

		if (($option == 'com_user' && $view == 'user' && $task == 'edit') || ($option == 'com_users' && $view == 'profile' && $layout == 'edit')) {
			if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php')) return true;
			$body = JResponse::getBody();
			if(strpos($body,'class="form-validate"')!==false){

				$user = hikashop_loadUser(true);
				$fieldsClass = hikashop_get('class.field');
				$extraFields = array(
					'user' => $fieldsClass->getFields('frontcomp',$user,'user')
				);
				if(!empty($extraFields['user'])){
					$null = array();
					$fieldsClass->addJS($null,$null,$null);
					$fieldsClass->jsToggle($extraFields['user'],$user,0);

					$data = '';
					if(version_compare(JVERSION,'1.6.0','<')) {
						$data .= '<style type="text/css">'."\r\n".
								'fieldset.hikashop_user_edit { border: 1px solid rgb(204, 204, 204); margin: 10px 0 15px; padding: 0px 10px 0px 10px; }'."\r\n".
								'.hikashop_user_edit legend { font-size: 1em; font-weight: bold; }'."\r\n".
								'.hikashop_user_edit dt { padding: 5px 5px 5px 0px; width: 13em; clear:left; float:left; }'."\r\n".
								'.hikashop_user_edit dd { margin-left: 14em; }'."\r\n".
								'</style>';
					}

					$data .= '<fieldset class="hikashop_user_edit"><legend>'.JText::_('HIKASHOP_USER_DETAILS').'</legend><dl>';
					foreach($extraFields['user'] as $fieldName => $oneExtraField) {
						$data .= '<dt><label>'.$fieldsClass->getFieldName($oneExtraField).'</label></dt><dd>';
						$onWhat='onchange';
						if($oneExtraField->field_type=='radio')
							$onWhat='onclick';
						$data .= $fieldsClass->display($oneExtraField,$user->$fieldName,'data[user]['.$fieldName.']',false,' '.$onWhat.'="hikashopToggleFields(this.value,\''.$fieldName.'\',\'user\',0);"').'</dd>';
					}
					$data .= '</dl></fieldset>';

					$body = preg_replace('#(<form[^>]*class="form-validate"[^>]*>.*</(fieldset|table)>)#Uis','$1'.$data, $body,1);
					JResponse::setBody($body);
				}
			}
		}

		$user=null;
		return $this->onLogoutUser($user);
	}
}